package org.ow2.util.ee.metadata.car.impl.configurator;

import java.util.List;

import org.ow2.util.ee.metadata.car.api.ICarClassMetadata;
import org.ow2.util.ee.metadata.car.api.ICarFieldMetadata;
import org.ow2.util.ee.metadata.car.api.ICarMethodMetadata;
import org.ow2.util.ee.metadata.car.impl.CarMethodMetadata;
import org.ow2.util.ee.metadata.common.impl.configurator.CommonMethodMetadataConfigurator;
import org.ow2.util.scan.api.configurator.metadata.specific.ISpecificClassConfigurator;
import org.ow2.util.scan.api.metadata.structures.JMethod;

/**
 * CarMethodMetadataConfigurator.
 * @author Gael Lalire
 */
public class CarMethodMetadataConfigurator extends
        CommonMethodMetadataConfigurator<ICarClassMetadata, ICarMethodMetadata, ICarFieldMetadata> {

    /**
     * Constructor.
     * @param jMethod signature
     * @param classMetadata parent
     * @param annotationParsingDesactived annotationParsingDesactived
     * @param specificClassConfiguratorList specificClassConfiguratorList
     */
    public CarMethodMetadataConfigurator(
            final JMethod jMethod,
            final ICarClassMetadata classMetadata,
            final boolean annotationParsingDesactived,
            final List<ISpecificClassConfigurator<ICarClassMetadata, ICarMethodMetadata, ICarFieldMetadata>>
                specificClassConfiguratorList) {
        super(new CarMethodMetadata(jMethod, classMetadata), specificClassConfiguratorList);

        if (!annotationParsingDesactived) {
            registerAnnotationVisitor();
        }
    }


}
